/*
 * Created on 04.01.2005
 *
 * $Id: Player.java,v 1.1 2005/06/24 13:56:04 boehm Exp $
 */
package casino;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 04.01.2005
 * @version $revision$
 */
public class Player {

    private String name = null;
    private Konto konto = null;
    
    /**
     * Zum Start gibts 5000 Chips als Startkapital.
     * @param name
     */
    public Player(String name) {
        this(name, new Konto(name, 5000));
    }
    
    public Player(String name, Konto konto) {
        this.name = name;
        this.konto = konto;
    }

    /**
     * Lassen wir den Computer automatisch den Wett-Einsatz taetigen -
     * 200 Chips auf "Pair" - die Chips dafür werden gleich vom Konto 
     * abgehoben.
     * <br>
     * FIXME: die RuntimeExeption bei konto.abheben() abfangen!
     * 
     * @return den Wett-Einsatz
     */
    public Einsatz getEinsatz() {
        Einsatz einsatz = new Einsatz();
        einsatz.setPair(200);
        konto.abheben(einsatz.getBetrag());
        return einsatz;
    }
    
    public void setGewinn(Einsatz gewinn) {
        konto.einzahlen(gewinn.getBetrag());
    }
    
    public int getKontostand() {
        return this.konto.abfragen();
    }
    
    public String toString() {
        return this.name;
    }
    
}
