/*
 * Created on 05.01.2005
 *
 * $Id$
 */
package casino.player;

import org.apache.log4j.*;
import casino.*;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 05.01.2005
 * @version $revision$
 */
public class DoubleBetPlayer extends Player {
    
    /** FIXME: eigentlich ist dafuer der LogAspect da... */
    private static Logger log = Logger.getLogger(DoubleBetPlayer.class); 
    
    /** hab ich beim letzten Mal gewonnen? */
    private Einsatz gewinn = null;
    
    /** letzten Einsatz merken */
    private Einsatz einsatz = null;

    /**
     * @author <a href="mailto:boehm@javatux.de">oliver</a>
     * @since 05.01.2005
     * @param name
     */
    public DoubleBetPlayer(String name) {
        super(name);
    }

    /**
     * @author <a href="mailto:boehm@javatux.de">oliver</a>
     * @since 05.01.2005
     * @param name
     * @param konto
     */
    public DoubleBetPlayer(String name, Konto konto) {
        super(name, konto);
    }
    
    public Einsatz getEinsatz() {
        if ((gewinn == null) || (gewinn.getPair() == 0)) {
            einsatz = doubleEinsatz();
            log.info("doppelter Einsatz (" + einsatz.getPair()
                    + " Chips) auf PAIR");
        } else {
            einsatz = new Einsatz();
            einsatz.setPair(1);
            log.info("setze 1 Chip auf PAIR");
        }
        super.setEinsatz(einsatz);
        return einsatz;
    }
    
    private Einsatz doubleEinsatz() {
        if (einsatz == null) {
            einsatz = new Einsatz();
            einsatz.setPair(1);
        } else {
            int betrag = einsatz.getPair() * 2;
            if (betrag > 500) {
                betrag = 500;
            }
            einsatz.setPair(betrag);
        }
        return einsatz;
    }
    
    /**
     * Gewinn merken fuer naechsten Einsatz
     */
    public void setGewinn(Einsatz gewinn) {
        super.setGewinn(gewinn);
        this.gewinn = gewinn;
    }

}
