/*
 * Created on 06.01.2005
 *
 * $Id$
 */
package casino.log;

import org.apache.log4j.*;

import org.aspectj.lang.*;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 06.01.2005
 * @version $revision$
 */
public abstract aspect AbstractLoggingAspect {

    //private static Logger log = Logger.getLogger(AbstractLoggingAspect.class);
    public abstract Logger getLogger();
   
    abstract pointcut logPoints(Object x);
    
    after(Object x) returning(Object r): logPoints(x) {
        String returned = "";
        if (r != null) {
            returned = " = " + r;
        }
        Signature sig = thisJoinPoint.getSignature();
        getLogger().info(x + ": " 
                + sig.getDeclaringType().getName() + "."
                + sig.getName() + "("
                + getArgsAsString(thisJoinPoint.getArgs()) + ")" + returned);
    }
    
    private String getArgsAsString(Object[] args) {
        if (args.length == 0) {
            return "";
        }
        String s = "'" + args[0] + "'";
        for (int i = 1; i < args.length; i++) {
            s += ", '" + args[i] + "'";
        }
        return s;
    }

}
