/*
 * Created on 05.01.2005
 *
 * $Id$
 */
package casino.player;

import casino.*;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 05.01.2005
 * @version $revision$
 */
public aspect RoulettePlayerAspect {
    
    private String RoulettePlayer.name = null;
    private Konto RoulettePlayer.konto = null;
    
    /**
     * Lassen wir den Computer automatisch den Wett-Einsatz taetigen -
     * 50 Chips auf "Pair" - die Chips dafür werden gleich vom Konto 
     * abgehoben.
     * 
     * @return den Wett-Einsatz
     */
    public Einsatz RoulettePlayer.getEinsatz() {
        Einsatz einsatz = new Einsatz();
        einsatz.setPair(50);
        this.setEinsatz(einsatz);
        return einsatz;
    }
    
    public void RoulettePlayer.setEinsatz(Einsatz einsatz) {
        konto.abheben(einsatz.getBetrag());
    }
    
    public void RoulettePlayer.setGewinn(Einsatz gewinn) {
        konto.einzahlen(gewinn.getBetrag());
    }
    
    public int RoulettePlayer.getKontostand() {
        return this.konto.abfragen();
    }
    
    public String RoulettePlayer.toString() {
        return this.name;
    }
    
    /**
     * Fuer den Zugriff auf "name" stellen wir noch diese Methode bereit
     */
    public void RoulettePlayer.setName(String name) {
        this.name = name;
    }
    
    /**
     * Um das Konto setzen zu koennen, stellen wir ebenfalls noch eine Methode
     * bereit.
     */
    public void RoulettePlayer.setKonto(Konto konto) {
        this.konto = konto;
    }
    
    ///////////////////////////////////////////////////////////////////////////
    
    /**
     * Und nun fuegen wir noch vor fuer die Player-Klasse zwei Konstruktoren
     * ein. Leider lassen diese sich nicht ueber die Default-Implementierung
     * des RoulettePlayer-Interfaces realsieren :-(
     * <br>
     * Standardmaessig erhaelt ein neuer Spieler ein Konto von 1000 Chips.
     * @param name Spieler-Name
     */
//    public Player.new(String name) {
//        this.name = name;
//        this.konto = new Konto(name, 1000);
//    }
//
//    public Player.new(String name, Konto konto) {
//        this.name = name;
//        this.konto = konto;
//    }
    
//    /**
//     * Das klappt leider auch nicht :-(
//     */
//    public RoulettePlayerAspect.new(String name) {
//        this.name = name;
//        this.konto = konto;
//    }

}
