/*
 * Created on 05.01.2005
 *
 * $Id$
 */
package casino.player;

import junit.framework.TestCase;
import casino.*;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 05.01.2005
 * @version $revision$
 */
public class DoubleBetPlayerTest extends PlayerTest {

    /**
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        player = new DoubleBetPlayer("John DoublePlayer");
    }
    
    /**
     * Wird der Einsatz wirklich nach jedem verlorenen Spiel verdoppelt?
     * Let's test!
     */
    public final void testDoubleEinsatz() {
        // ein paar mal gewinnen lassen, dass Geld auf dem Konto ist
        for (int i = 0; i < 100; i++) {
            Einsatz einsatz = player.getEinsatz();
            assertEquals(1, einsatz.getBetrag());
            einsatz.setPair(2);
            player.setGewinn(einsatz);
        }
        for (int i = 1; i < 500; i *= 2) {
            Einsatz einsatz = player.getEinsatz();
            assertEquals(i, einsatz.getBetrag());
            player.setGewinn(new Einsatz());
        }
        assertEquals(500, player.getEinsatz().getBetrag());
    }

}
