/*
 * Created on 28.02.2005
 *
 * $Id$
 */
package verkehrs;

import verkehrs.utils.MyObservable;


public aspect MVCAspect {
    
    pointcut modelChanged() :
        //set (* *.*) && within(MyObservable+);
        //set (* MyObservable+.*) && @within(Model);
        set (* *.*) && @within(Model);
    
    after(MyObservable x) : modelChanged() && this(x) {
        //System.out.println(thisJoinPoint + " -> " + x);
        x.setChanged();
        x.notifyObservers();
    }
    
    
    
    /*
     * Model soll weder View noch Controller kennen
     */
    
    declare warning
        : (call((@View *).new(..)) || call((@Controller *).new(..)))
          && @within(Model)
        : "Model sollte View und Controller nicht kennen";



          
    /*
     * Alle Models bekommen MyDeclaration als Oberklasse
     */
    
    declare parents : (@Model *) extends MyObservable;

}
