/*
 * Created on 05.01.2005
 *
 * $Id$
 */
package casino.player;

import casino.*;

/**
 * Dieser Aspekt enthaelt die Default-Implementierung fuer einen Spieler.
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 05.01.2005
 * @version $revision$
 */
public aspect RoulettePlayerAspect {
    
    private String RoulettePlayer.name = null;
    private Konto RoulettePlayer.konto = null;
    
    /**
     * Lassen wir den Computer automatisch den Wett-Einsatz taetigen -
     * 50 Chips auf "Pair" - die Chips dafür werden gleich vom Konto 
     * abgehoben.
     * 
     * @return den Wett-Einsatz
     */
    public Einsatz RoulettePlayer.getEinsatz() {
        Einsatz einsatz = new Einsatz();
        einsatz.setPair(50);
        this.setEinsatz(einsatz);
        return einsatz;
    }
    
    /**
     * Der Einsatz geht vom Konto ab.
     */
    public void RoulettePlayer.setEinsatz(Einsatz einsatz) {
        konto.abheben(einsatz.getBetrag());
    }
    
    /**
     * Der Gweinn wird auf dem Konto verbucht.
     */
    public void RoulettePlayer.setGewinn(Einsatz gewinn) {
        konto.einzahlen(gewinn.getBetrag());
    }
    
    /**
     * Wieviel ist denn noch auf dem Konto?
     */
    public int RoulettePlayer.getKontostand() {
        return this.konto.abfragen();
    }
    
    /**
     * Spielername zurueckgeben.
     */
    public String RoulettePlayer.toString() {
        return this.name;
    }
    
    /**
     * Fuer den Zugriff auf "name" stellen wir noch diese Methode bereit
     */
    public void RoulettePlayer.setName(String name) {
        this.name = name;
    }
    
    /**
     * Um das Konto setzen zu koennen, stellen wir ebenfalls noch eine Methode
     * bereit.
     */
    public void RoulettePlayer.setKonto(Konto konto) {
        this.konto = konto;
    }

}
