/*
 * Created on 02-Jan-2005
 */
package casino;

/**
 * Ein einfaches Bankkonto fuer eine Casino-Loesung
 * @author oliver
 */
public class Konto {

    private String inhaber = "unbekannt";
    
    /**
     * damit PersistenceAspect darauf zugreifen darf, ist "kontostand"
     * jetzt protected
     */
    protected int kontostand = 0;
    
    /**
     * Lege ein Konto für "name" an.
     * @param name
     */
    public Konto(String name) {
        this.inhaber = name;
    }
    
    /**
     * Lege ein Konto für "name" an.
     * @param name
     * @param einzahlung    Start-Kapital
     */
    public Konto(String name, int einzahlung) {
        this(name);
        this.kontostand = einzahlung;
    }
    
    /**
     * Wer ist denn der Konto-Inhaber?
     * @return
     */
    public String getInhaber() {
        return this.inhaber;
    }

    /**
     * Liefert den Kontostand zurueck.
     * @return
     */
    public int abfragen() {
        return this.kontostand;
    }
    
    /**
     * Betrag einzahlen.
     * @param betrag
     */
    public void einzahlen(int betrag) {
        kontostand = kontostand + betrag;
    }

    /**
     * Betrag abheben.
     * Die Kontoueberziehung muessen wir jetzt selber machen, da der
     * entsprechende Aspekt fehlt, wenn wir ein Java-Projekt daraus
     * machen.
     * 
     * @param betrag
     */
    public void abheben(int betrag) {
        if (betrag > kontostand) {
            throw new RuntimeException("Konto ueberzogen");
        }
        kontostand = kontostand - betrag;
    }
    
    public String toString() {
        return "Konto " + this.inhaber;
    }

}
