/*
 * Created on 08.01.2005
 *
 * $Id$
 */
package crypt;

/**
 * Das Schoene am Rot13-Algorithmus ist seine Einfachheit. Wenn man 2x
 * den Algorithmus anwendet, kommt wieder das gleiche Wort heraus.
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 08.01.2005
 * @version $revision$
 */
public class Rot13 {
    
    private String crypted = null;

    /**
     * @author <a href="mailto:boehm@javatux.de">oliver</a>
     * @since 08.01.2005
     * 
     */
    public Rot13(String s) {
        this.crypted = crypt(s);
    }
    
    /**
     * Nothing to do - it's already crypted!
     * @return
     */
    public String crypt() {
        return this.crypted;
    }
    
    public String decrypt() {
        return decrypt(this.crypted);
    }
    
    static public String crypt(String s) {
        StringBuffer sbuf = new StringBuffer(s);
        for (int i = 0; i < sbuf.length(); i++) {
            sbuf.setCharAt(i, crypt(sbuf.charAt(i)));
        }
        return sbuf.toString();
    }
    
    /**
     * It's the same algorithmus as 'crypt'.
     * @param s
     * @return
     * @see #crypt(String)
     */
    static public String decrypt(String s) {
        return crypt(s);
    }
    
    static public char crypt(char c) {
        if (Character.isLetter(c)) {
            char z = ((Character.isLowerCase(c)) ? 'z' : 'Z');
            c += 13;
            if (c > z) {
                c -= 26;
            }
        }
        return c;
    }
    
    public String toString() {
        return crypted;
    }

}
