/*
 * Created on 14.04.2005
 *
 * $Id$
 */
package pattern.composite;

import java.util.Collection;

public aspect CompositeAspect {
    
    /*
     * @Node and @Leaf are both from type "Composite"
     */
    
    declare parents : (@Node *) implements Composite;

    declare parents : (@Leaf *) implements Composite;

    Object around() : execution(* Composite+.getChildren()) && @this(Leaf) {
        return null;
    }
    


    /*
     * provide default implementation for Composite pattern
     */

    private CompositeCollection Composite.entries = new CompositeCollection();

    public void Composite.add(Composite composite) {
        entries.add(composite);
    }

    public void Composite.remove(Composite composite) {
        entries.remove(composite);
    }

    public Collection<Composite> Composite.getChildren() {
        return entries.getChildren();
    }
    
    
    
    //  logging / debugging
    
    pointcut allExecutes() : 
        (execution(* dir.*.*(..)) || execution(dir.*.new(..)));
    
//    before() : allExecutes() {
//        System.out.println("--> " + thisJoinPoint);
//    }
//    
//    after() : allExecutes() {
//        System.out.println("<-- " + thisJoinPoint);
//    }
    
//    Object around() : allExecutes() {
//        try {
//            return proceed(); 
//        } catch (NullPointerException e) {
//            System.out.println("NPE in " + thisJoinPoint);
//            return null;
//        }
//    }

}
