/*
 * Created on 09.01.2005
 *
 * $Id$
 */
package casino.log;

import org.apache.commons.logging.*;


/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 09.01.2005
 * @version $revision$
 */
public aspect ParanoiaLogging extends AbstractLoggingAspect {

    private static Log log = LogFactory.getLog(ParanoiaLogging.class);

    /**
     * Gibt den Logger fuer diesen Aspekt zurueck.
     */
    public Log getLogger() {
        return log;
    }

    /**
     * toString() ist immer StackOverflow-anfaellig - filtern wir ihn lieber
     * aus. Auch unterhalb von toString() kommt es gern zu Rekursionen.
     */
    pointcut logPoints(Object x) : 
        (execution(* *..*.*(..))
        || call(* *..*(..)))
        && !cflowbelow(execution(public String *..*.toString()))
        && !within(ParanoiaLogging)
        && !within(AbstractLoggingAspect)
        && !within(casino.utils.*)
        && this(x);

}
