/*
 * Created on 04.01.2005
 *
 * $Id$
 */
package casino.player;

import casino.*;

/**
 * Ein einfacher Spieler.
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 04.01.2005
 * @version $revision$
 */
public class Player implements RoulettePlayer {

    /**
     * Der Konstruktor kann leider nicht ueber die Default-Implementierung
     * bereitgestellt werden.
     * 
     * @param name  Spielername
     */
    public Player(String name) {
        this(name, new Konto(name, 20000));        
    }
    
    /**
     * @param name  Spielername
     * @param konto Startkapital
     */
    public Player(String name, Konto konto) {
        this.name = name;
        this.konto = konto;        
    }
    
    /**
     * Lassen wir den Computer automatisch den Wett-Einsatz taetigen -
     * 50 Chips auf "Pair" - die Chips dafür werden gleich vom Konto 
     * abgehoben.
     * 
     * @return den Wett-Einsatz
     */
    public Einsatz getEinsatz() {
        Einsatz einsatz = new Einsatz();
        einsatz.setPair(50);
        this.setEinsatz(einsatz);
        return einsatz;
    }
    
    /**
     * Der Einsatz geht vom Konto ab.
     */
    public void setEinsatz(Einsatz einsatz) {
        konto.abheben(einsatz.getBetrag());
    }
    
    /**
     * Der Gweinn wird auf dem Konto verbucht.
     */
    public void setGewinn(Einsatz gewinn) {
        konto.einzahlen(gewinn.getBetrag());
    }
    
    /**
     * Spielername zurueckgeben.
     */
    public String toString() {
        return this.name;
    }

}
