/*
 * Created on 09.01.2005
 *
 * $Id$
 */
package casino.utils;


/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 09.01.2005
 * @version $revision$
 */
public aspect MemWatcherAspect {
    
    public static Runtime runtime;
    public static long memTotal;
    public static long memMax;
    public static long memAlarm;    // Schwellwert fuer Alarm
    
    static {
        init();
    }
    
    static private void init() {
        runtime = Runtime.getRuntime();
        memTotal = runtime.totalMemory();
        memAlarm = memTotal / 2;
        memMax   = runtime.maxMemory();
        System.err.println("total memory: " + memTotal / 1024 + " KB");
        System.err.println("max.  memory: " + memMax   / 1024 + " KB");
        System.err.println("free  memory: " + runtime.freeMemory() / 1024
                + "KB");
    }

    after() : call(* *..*(..)) && !within(MemWatcherAspect) {
        if (runtime.freeMemory() < memAlarm) {
            System.err.println("ALARM - weniger als " + memAlarm / 1024
                    + " KB freier Speicher nach "
                    + thisJoinPoint.toShortString() + "@"
                    + thisJoinPoint.getSourceLocation());
            memAlarm /= 2;
            runtime.gc();
        }
        if (runtime.totalMemory() > memTotal) {
            memTotal = runtime.totalMemory();
            System.err.println("HeapSize wurde auf " + memTotal / 1024
                    + " KB erhoeht!");
        }
    }

}
